// Copyright (c) 2009-2011 Ignacio Castano <castano@gmail.com>
// Copyright (c) 2007-2009 NVIDIA Corporation -- Ignacio Castano <icastano@nvidia.com>
// 
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

#pragma once
#ifndef NVTT_TEXTURE_TOOLS_H
#define NVTT_TEXTURE_TOOLS_H

#ifndef NVTT_DEFINES_H
#include <NVTextureTools/TextureToolDefines.h>
#endif

#ifndef NVTT_BASE_H
#include <NVTextureTools/TextureToolsBase.h>
#  endif

#ifndef NVTT_H
#include <NVTextureTools/TextureTools.h>
#endif

#ifndef NV_TT_CONTEXT_H
#include <NVTextureTools/Context.h>
#  endif

#ifndef NVTT_WRAPPER_H
#include <NVTextureTools/nvtt_wrapper.h>
#endif

#ifndef NVTT_COMPRESSOR_H
#include <NVTextureTools/Compressor.h>
#endif

#ifndef NVTT_COMPRESSORDXT_H
#include <NVTextureTools/CompressorDXT.h>
#endif

#ifndef NVTT_COMPRESSORDX9_H
#include <NVTextureTools/CompressorDX9.h>
#endif

#ifndef NVTT_COMPRESSORDX10_H
#include <NVTextureTools/CompressorDX10.h>
#endif

#ifndef NVTT_COMPRESSORDX11_H
#include <NVTextureTools/CompressorDX11.h>
#endif

#ifndef NVTT_COMPRESSORRGB_H
#include <NVTextureTools/CompressorRGB.h>
#endif

#ifndef NVTT_COMPRESSORRGBE_H
#include <NVTextureTools/CompressorRGBE.h>
#endif

#ifndef NV_TT_QUICKCOMPRESSDXT_H
#include <NVTextureTools/QuickCompressDXT.h>
#endif

#ifndef NV_TT_OPTIMALCOMPRESSDXT_H
#include <NVTextureTools/OptimalCompressDXT.h>
#endif

#ifndef NV_TT_COMPRESSIONOPTIONS_H
#include <NVTextureTools/CompressionOptions.h>
#endif

#ifndef NVTT_INPUTOPTIONS_H
#include <NVTextureTools/InputOptions.h>
#endif

#ifndef NV_TT_OUTPUTOPTIONS_H
#include <NVTextureTools/OutputOptions.h>
#endif

//#ifndef NVTT_DEFINES_H
#include <NVTextureTools/SingleColorLookup.h>
//#endif

#ifndef NVTT_TEXIMAGE_H
#include <NVTextureTools/TexImage.h>
#endif

#ifndef NV_TT_CUDACOMPRESSORDXT_H
#include <NVTextureTools/CudaCompressorDXT.h>
#endif

#endif // NVTT_TEXTURE_TOOLS_H



